/* 
 * Copyright (c) 2004 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef	__CAMERA_H__
#define	__CAMERA_H__


class Camera {
	// ===================================================================
	// - Public methods --------------------------------------------------
	// ===================================================================
 public:
	Camera (class Screen *screen);
	~Camera (void);

	void look (void);
    void look_at (float eyeX, float eyeY, float eyeZ, 
                  float centerX, float centerY, float centerZ,
                  float upX, float upY, float upZ);

	void resize (void);


	// ===================================================================
	// - Private features ------------------------------------------------
	// ===================================================================
 private:
	class Screen *		_screen;
};

#endif // __CAMERA_H__
