/* 
 * Copyright (c) 2004 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include <cstdio>
#include <cstdlib>
#include "log.h"

// ================================================================================
// _log
// --------------------------------------------------------------------------------
// Very basic log function to log various messages. Do not use directly but use
// macros defined in log.h instead.
// ================================================================================
void _log (int level, const char *fmt, ...) {
	char *s = 0;
	va_list ap;

	switch (level) {
	case LOG_LEVEL_ERROR:
		s = "ERROR: ";
		break;
	case LOG_LEVEL_CRITICAL:
		s = "CRITICAL: ";
		break;
	case LOG_LEVEL_WARNING:
		s = "WARNING: ";
		break;
	case LOG_LEVEL_MESSAGE:
	case LOG_LEVEL_INFO:
		s = "";
		break;
	case LOG_LEVEL_DEBUG:
		s = "DEBUG: ";
		break;
	default:
		break;
	}
	if (level != LOG_LEVEL_DEBUG) {
		fprintf (stderr, "%s", s);
		va_start (ap, fmt);
		vfprintf(stderr, fmt, ap);
		va_end (ap);
		fprintf (stderr, "\n");

	} else {
#ifdef DEBUG
		fprintf (stderr, "%s", s);
		va_start (ap, fmt);
		vfprintf (stderr, fmt, ap);
		va_end (ap);
		fprintf (stderr, "\n");
#endif
	}
}

