/* 
 * Copyright (c) 2004 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _LOG_H
#define _LOG_H

#include <stdarg.h>

#define	LOG_LEVEL_ERROR		(1 << 0)
#define	LOG_LEVEL_CRITICAL	(1 << 1)
#define	LOG_LEVEL_WARNING	(1 << 2)
#define	LOG_LEVEL_MESSAGE	(1 << 3)
#define	LOG_LEVEL_INFO		(1 << 4)
#define	LOG_LEVEL_DEBUG		(1 << 5)

#define log_error(args...)		_log (LOG_LEVEL_ERROR,    args)
#define log_critical(args...)	_log (LOG_LEVEL_CRITICAL, args)
#define log_warning(args...)	_log (LOG_LEVEL_WARNING,  args)
#define log_message(args...)	_log (LOG_LEVEL_MESSAGE,  args)
#define log_info(args...)		_log (LOG_LEVEL_INFO,     args)
#define log_debug(args...)		_log (LOG_LEVEL_DEBUG,    args)

void _log (int level, const char *fmt, ...);

#endif // _LOG_H

