/* 
 * Copyright (c) 2004 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef		_SINGLETON_H
#define		_SINGLETON_H


template <typename T> class Singleton {
 public:
	// ===================================================================
	// - Public methods --------------------------------------------------
	// ===================================================================
	static T *it (void)		// Get the real singleton object
		{
			if (object_ == 0)
				object_ = new T;
			return object_;
		};

 protected:
	// ===================================================================
	// - Protected methods -----------------------------------------------
	// ===================================================================
	Singleton (void) {};		// Constructor
	~Singleton (void) {};		// Destructor


 private:
	// ===================================================================
	// - Private attributes ----------------------------------------------
	// ===================================================================
	static T *	object_;	// The real instance of the object
};

template <typename T> T *Singleton<T>::object_ = 0;


#endif	// __SINGLETON_H
