/* 
 * Copyright (c) 2004 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef	_TIMER_H
#define	_TIMER_H

#include <SDL/SDL.h>


class Timer {
	// ===================================================================
	// - Public methods --------------------------------------------------
	// ===================================================================
 public:
	Timer (void);
	~Timer (void);
	void pause (void);
	void unpause (void);
	float wait_next_tick (void);
    bool paused (void);


	// ===================================================================
	// - Private features ------------------------------------------------
	// ===================================================================
 private:
	unsigned	fps_;
	bool		paused_;
	Uint32	    last_tick_;
	Uint32		pause_tick_;
};

#endif // _TIMER_H
